//
//  ColorPickerView.m
//  BookTemp
//
//  Created by  on 12-1-6.
//  Copyright 2012年 __MyCompanyName__. All rights reserved.
//

#import "ColorPickerView.h"

#define pointY 100

@implementation ColorPickerView
@synthesize delegate;
@synthesize colorImg;
@synthesize selColorImg;
@synthesize lastColor;

@synthesize btnHSBH;
@synthesize btnHSBS;
@synthesize btnHSBB;
@synthesize btnRGBR;
@synthesize btnRGBG;
@synthesize btnRGBB;
@synthesize txtHSBH;
@synthesize txtHSBS;
@synthesize txtHSBB;
@synthesize txtRGBR;
@synthesize txtRGBG;
@synthesize txtRGBB;

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
        self.backgroundColor = [UIColor grayColor];
        
        UILabel *lblTitle = [[UILabel alloc]initWithFrame:CGRectMake(110, pointY - 60, 100, 28)];
        lblTitle.font = [UIFont systemFontOfSize:18];
        lblTitle.text = @"颜色选择";
        lblTitle.backgroundColor = [UIColor clearColor];
        lblTitle.textColor = [UIColor whiteColor];
        lblTitle.textAlignment = UITextAlignmentCenter;
        [self addSubview:lblTitle];
        
        colorImg = [[UIImageView alloc]initWithFrame:CGRectMake(20, pointY, 210, 210)];
        colorImg.image = [UIImage imageNamed:@"allcolor2.png"];
        [self addSubview:colorImg];
        
        selColorImg = [[UIImageView alloc]initWithFrame:CGRectMake(250, pointY + 20, 50, 50)];
        selColorImg.backgroundColor = [UIColor colorWithRed:0 green:1 blue:1 alpha:1];
        lastColor = selColorImg.backgroundColor;
        [self addSubview:selColorImg];
        
        selImage =[[UIImageView alloc]initWithFrame:CGRectMake((210 + 20)/2, pointY + (210-20)/2, 20, 20)];
        selImage.image = [UIImage imageNamed:@"select.png"];
        [self addSubview:selImage];
        
        UIButton *btnOk=[UIButton buttonWithType:UIButtonTypeRoundedRect];
        [btnOk setTitle:@"确定" forState:UIControlStateNormal];
        btnOk.frame = CGRectMake(50, 400, 100, 30);
        btnOk.backgroundColor = [UIColor clearColor];
        btnOk.tag =201;
        [btnOk addTarget:delegate action:@selector(showBookInfo:) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:btnOk];
        
        UIButton *btnCancel=[UIButton buttonWithType:UIButtonTypeRoundedRect];
        [btnCancel setTitle:@"取消" forState:UIControlStateNormal];
        btnCancel.frame = CGRectMake(170, 400, 100, 30);
        btnCancel.backgroundColor = [UIColor clearColor];
        btnCancel.tag =202;
        [btnCancel addTarget:delegate action:@selector(showBookInfo:) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:btnCancel];
    }
    return self;
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
}
*/

- (void) touchesEnded:(NSSet*)touches withEvent:(UIEvent*)event {
	if (self.hidden==YES) {
		//color wheel is hidden, so don't handle  this as a color wheel event.
		[[self nextResponder] touchesEnded:touches withEvent:event];
		return;
	}
	
	UITouch* touch = [touches anyObject];
	CGPoint point = [touch locationInView:colorImg]; //where image was tapped
    if(point.x < 0 || point.x > 210 || point.y<0 || point.y >210){
        return;
    }
    if(point.y < 105){
        selImage.image = [UIImage imageNamed:@"select2.png"];
    }else
    {
        selImage.image = [UIImage imageNamed:@"select.png"];
    }
    selImage.center = CGPointMake(point.x + 20, point.y + pointY);
	lastColor = [self getPixelColorAtLocation:point]; 
	//NSLog(@"color: %@",lastColor);
    selColorImg.backgroundColor = lastColor;
}
- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch* touch = [touches anyObject];
	CGPoint point = [touch locationInView:colorImg]; //where image was tapped
    if(point.x < 0 || point.x > 211 || point.y<0 || point.y >211){
        return;
    }
    if(point.y < 105){
        selImage.image = [UIImage imageNamed:@"select2.png"];
    }else
    {
        selImage.image = [UIImage imageNamed:@"select.png"];
    }
    selImage.center = CGPointMake(point.x + 20, point.y + pointY);
	lastColor = [self getPixelColorAtLocation:point]; 

    selColorImg.backgroundColor = lastColor;
    
}

- (UIColor*) getPixelColorAtLocation:(CGPoint)point {
	UIColor* color = nil;
	CGImageRef inImage = colorImg.image.CGImage;
	// Create off screen bitmap context to draw the image into. Format ARGB is 4 bytes for each pixel: Alpa, Red, Green, Blue
	CGContextRef cgctx = [self createARGBBitmapContextFromImage:inImage];
	if (cgctx == NULL) { return nil; /* error */ }
	
    size_t w = CGImageGetWidth(inImage);
	size_t h = CGImageGetHeight(inImage);
	CGRect rect = {{0,0},{w,h}}; 
	
	// Draw the image to the bitmap context. Once we draw, the memory 
	// allocated for the context for rendering will then contain the 
	// raw image data in the specified color space.
	CGContextDrawImage(cgctx, rect, inImage); 
	
	// Now we can get a pointer to the image data associated with the bitmap
	// context.
	unsigned char* data = CGBitmapContextGetData (cgctx);
	if (data != NULL) {
		//offset locates the pixel in the data from x,y. 
		//4 for 4 bytes of data per pixel, w is width of one row of data.
		int offset = 4*((w*round(point.y))+round(point.x));
		int alpha =  data[offset]; 
		int red = data[offset+1]; 
		int green = data[offset+2]; 
		int blue = data[offset+3]; 
		NSLog(@"offset: %i colors: RGB A %i %i %i  %i",offset,red,green,blue,alpha);
		color = [UIColor colorWithRed:(red/255.0f) green:(green/255.0f) blue:(blue/255.0f) alpha:(alpha/255.0f)];
	}
	
	// When finished, release the context
	CGContextRelease(cgctx); 
	// Free image data memory for the context
	if (data) { free(data); }
	
	return color;
}



- (CGContextRef) createARGBBitmapContextFromImage:(CGImageRef) inImage {
	
	CGContextRef    context = NULL;
	CGColorSpaceRef colorSpace;
	void *          bitmapData;
	int             bitmapByteCount;
	int             bitmapBytesPerRow;
	
	// Get image width, height. We'll use the entire image.
	size_t pixelsWide = CGImageGetWidth(inImage);
	size_t pixelsHigh = CGImageGetHeight(inImage);
	
	// Declare the number of bytes per row. Each pixel in the bitmap in this
	// example is represented by 4 bytes; 8 bits each of red, green, blue, and
	// alpha.
	bitmapBytesPerRow   = (pixelsWide * 4);
	bitmapByteCount     = (bitmapBytesPerRow * pixelsHigh);
	
	// Use the generic RGB color space.
	colorSpace = CGColorSpaceCreateDeviceRGB();
    
	if (colorSpace == NULL)
	{
		fprintf(stderr, "Error allocating color space\n");
		return NULL;
	}
	
	// Allocate memory for image data. This is the destination in memory
	// where any drawing to the bitmap context will be rendered.
	bitmapData = malloc( bitmapByteCount );
	if (bitmapData == NULL) 
	{
		fprintf (stderr, "Memory not allocated!");
		CGColorSpaceRelease( colorSpace );
		return NULL;
	}
	
	// Create the bitmap context. We want pre-multiplied ARGB, 8-bits 
	// per component. Regardless of what the source image format is 
	// (CMYK, Grayscale, and so on) it will be converted over to the format
	// specified here by CGBitmapContextCreate.
	context = CGBitmapContextCreate (bitmapData,
									 pixelsWide,
									 pixelsHigh,
									 8,      // bits per component
									 bitmapBytesPerRow,
									 colorSpace,
									 kCGImageAlphaPremultipliedFirst);
	if (context == NULL)
	{
		free (bitmapData);
		fprintf (stderr, "Context not created!");
	}
	
	// Make sure and release colorspace before returning
	CGColorSpaceRelease( colorSpace );
	
	return context;
}


@end
